\ Looplicht met regelbare snelheid op poort-B, codelengte: 218 bytes.

90S2313                                 \ Compileer voor AT90S2313
NEEDS TARGET.FRT
PORTB SFR LEDS                          \ Poort-B met 8 leds
PORTD SFR INGANG                        \ Ingang met 2 schakelaars
                                        \ op bit 2 en 3
: 10MS          ( u -- )                \ Wacht u maal 10 millisec.
    ?DUP IF  0 DO  10 MS  LOOP  THEN
    ;

: WACHT         ( -- )                  \ Wacht 0 tot 120 millisec
    FROM INGANG INVERT                  \ Schakelaars zitten aan de massa !
    $0C AND                             \ Alleen bit 2 en 3 zijn geldig
    10MS                                \ Wacht INGANG * 10 millisec.
    ;

: NAAR-LEDS     ( x -- )                \ Zet x op de leds
    INVERT  TO LEDS                     \ Inverteer x en stuur leds aan
    ;

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    -1 NAAR-LEDS  250 MS                \ Alle leds aan
    0 NAAR-LEDS   250 MS                \ Alle leds uit
    ;

: LOOPLICHT     ( -- )                  \ Een eenvoudig looplicht
    SETUP  -1 SETDIR LEDS               \ Installeer Forth stacks
    0 SETDIR INGANG  -1 TO INGANG       \ Ingang met pullup
    KNIPPER
    BEGIN
        8 0 DO                          \ Doe lus acht maal
            1 I LSHIFT                  \ Maak bitpatroon
            NAAR-LEDS                   \ Zet patroon op de leds
            WACHT                       \ Wacht even
        LOOP
    AGAIN                               \ Begin weer opnieuw
    ;  MAIN
