\ Analoog naar digitaal omzetting met de TLC549IP (294 bytes).

90S2313                                 \ Compileer voor AT90S2313
NEEDS TARGET.FRT
PORTB SFR LEDS                          \ Poort-B met 8 leds
PORTD 4 BIT-SFR ADC-KLOK                \ Klokpuls invoer PD.4
PORTD 5 BIT-SFR ADC-DATA                \ Data uitvoer PD.5
PORTD 6 BIT-SFR ADC-SELECTEER           \ Activeer invoer PD.6

: ADC               ( -- u )            \ Doe een AD-omzetting
    FALSE TO ADC-KLOK                   \ Stop lezen van analoge invoer
    TRUE TO ADC-SELECTEER               \ Start AD-omzetting
    9 0 DO  LOOP                        \ Conversie duurt max. 17 us 
    FALSE TO ADC-SELECTEER              \ Start uitlezen
    NOOP  FROM ADC-DATA 1 AND           \ Lees databit 7
    7 0 DO                              \ Lees resterende 7 databits
        TRUE TO ADC-KLOK
        FALSE TO ADC-KLOK               \ Schuif volgend bit naar buiten
        2 *  FROM ADC-DATA  1 AND  OR   \ Schaal data in en lees volgend bit
    LOOP
    TRUE TO ADC-KLOK                    \ Blijf analoge invoer lezen
    ;

: NAAR-LEDS     ( u -- )                \ Print data binair
    INVERT TO LEDS
    ;

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    -1 NAAR-LEDS  250 MS                \ Alle leds aan
    0 NAAR-LEDS   250 MS                \ Alle leds uit
    ;

: TOON-ADC      ( -- )                  \ Toon omzetting op LEDS
    SETUP  -1 SETDIR LEDS
    1 SETDIR ADC-KLOK
    0 SETDIR ADC-DATA  1 TO ADC-DATA    \ Ingang met pullup
    1 SETDIR ADC-SELECTEER
    KNIPPER
    BEGIN  ADC  NAAR-LEDS  AGAIN        \ Lees ADC, en toon uitkomst
    ;  MAIN

\ Einde
