\ Een motor vermogensregeling via Puls Breedte Modulatie, 82 bytes

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

TCCR1A SFR T1-CONTROLA                  \ Bestuur timer 1
TCCR1B SFR T1-CONTROLB
OCR1AL SFR AANPULS
PORTB 3 BIT-SFR PBM

: SETUP-PBM         ( -- )              \ Freq. ~7800 Hz
    $81 TO T1-CONTROLA                  \ 8 bit PBM & normale PBM
    $01 TO T1-CONTROLB                  \ Gebruik CPU klok
    1 SETDIR PBM                        \ OC1 (PB.3) is uitgang
    CLEAR AANPULS                       \ PBM = 0
    ;


: ZET-PULSBREEDTE   ( u -- )            \ Zet snelheid van 0 to 15
    DUP CSWAP +  TO AANPULS
    ;


\ Motor regeling demonstratie

PORTD SFR INGANG                        \ Ingang met de schakelaars PD.0-PD.3

: ZET-SNELHEID      ( -- u )            \ Lees schakelaar en inverteer
    FROM INGANG INVERT  $F AND          \ het resultaat, laagste 4 bits zijn
    ZET-PULSBREEDTE                     \ geldig. Zet de motorsnelheid.
    ;

: REGEL-MOTOR       ( -- )              \ Regel een gelijkstroom motor
    SETUP   SETUP-PBM
    $F0 SETDIR INGANG  $FF TO INGANG
    BEGIN  ZET-SNELHEID  AGAIN
    ;  MAIN

                              ( Einde )
