\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : TINYSLP.FRT
\ DESCRIPTION : Demonstreer gebruik van Power-down mode
\ CATEGORY    : Voorbeeld, afmeting: 124 bytes.
\ AUTHOR      : Willem Ouwerkerk, March 05, 2000
\ LAST CHANGE : Willem Ouwerkerk, March 17, 2000
\ ----------------------------------------------------------------------

90S2343                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

\ 1 SET-CRYSTAL  NEEDS MS.FRT

PORTB SFR LEDS                          \ 8 Leds op poort B

: DEMO          ( -- )
    SETUP  -1 SETDIR LEDS               \ Leds zijn uitgangen
    CLEAR LEDS  250 MS                  \ Leds aan en wacht
    BEGIN
        8 FOR                           \ 8 maal
            1
            4 FOR                       \ looplicht
                DUP 8 = IF  2*  THEN
                DUP INVERT TO LEDS      \ Zet led aan en wacht
                2*  100 MS
            NEXT
            DROP
        NEXT
        SET LEDS                        \ Alle leds uit
        SLEEP                           \ Ga maar slapen
    AGAIN
    ;  MAIN

                              ( Einde )
