\ In- en Uitvoer routine voor PCF8574(a) chips (130 bytes) = fl 9,95
\ Heeft I2C-PRIM.FRT nodig uit de bibliotheek ( LIB ).

$40 CONSTANT I/O-ID1                    \ PCF8574 identificatie adres
$70 CONSTANT I/O-ID2                    \ PCF8574a identificatie adres

\G Zet data 'x' in de PCF8574 met als device-id 'chip'.
: !BYTE         ( x chip -- )           \ I2C-8574 "store-byte"
    START-BIT
    BYTE-UIT                            \ Stuur schrijfadres naar chip en
    BYTE-UIT                            \ daarna de databyte
    STOP-BIT                            \ Klaar
    ;

\G Lees data 'x' van de PCF8574 met als device-id 'chip'.
: @BYTE         ( chip -- x )           \ I2C-8574 "fetch-byte"
    START-BIT
    1+ BYTE-UIT                         \ Stuur leesadres naar chip en
    BYTE-IN                             \ lees databyte van ingang
    NACK-BIT
    STOP-BIT
    ;

\ Einde