\ Binaire teller met AT90S2313 op poort-B, codelengte: 110 bytes.

90S2313                                 \ Compileer voor AT90S2313 en voeg
NEEDS TARGET.FRT                        \ labels voor het gekozen type toe

PORTB SFR LEDS                          \ Poort-B met 8 leds

: TELLER        ( -- )                  \ Een binaire teller
    SETUP  -1 SETDIR LEDS
    0 TO LEDS   250 MS                  \ Alle leds aan en wacht
    -1 TO LEDS  250 MS                  \ Alle leds uit en wacht
    0                                   \ Zet teller op de stack
    BEGIN
        1 +                             \ Verhoog teller op de stack
        DUP                             \ Maak kopie
        INVERT TO LEDS                  \ Keer om en stuur leds aan
        25 MS                           \ Wacht even
    AGAIN                               \ Begin weer opnieuw
    ;  MAIN

