\ Analoog naar digitaal omzetting met de TLC549IP: 316 bytes.

90S2313                                 \ Compileer voor AT90S2313
NEEDS TARGET.FRT
PORTB SFR LEDS                          \ Poort-B met 8 leds
PORTD 4 BIT-SFR ADC-KLOK                \ Klokpuls invoer P3.4
PORTD 5 BIT-SFR ADC-DATA                \ Data uitvoer P3.5
PORTD 6 BIT-SFR ADC-SELECTEER           \ Activeer invoer P3.6

: ADC               ( -- u )            \ Doe een AD-omzetting
    CLEAR ADC-KLOK                      \ Stop lezen van analoge invoer
    SET ADC-SELECTEER                   \ Start AD-omzetting
    9 0 DO  LOOP                        \ Conversie duurt min. 17 us 
    CLEAR ADC-SELECTEER                 \ Start uitlezen
    NOOP NOOP NOOP  FROM ADC-DATA 1 AND \ Lees databit 7
    7 0 DO                              \ Lees resterende 7 databits
        SET ADC-KLOK
        CLEAR ADC-KLOK                  \ Schuif volgend bit naar buiten
        2*  FROM ADC-DATA  1 AND  OR    \ Schaal data in, lees volgend bit
    LOOP
    SET ADC-KLOK                        \ Blijf analoge invoer lezen
    ;

: NAAR-LEDS     ( u -- )                \ Print data binair
    INVERT TO LEDS
    ;

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    -1 NAAR-LEDS  250 MS
    0 NAAR-LEDS   250 MS
    ;

: BEELD-AF      ( u -- )                \ Toon met VU- of thermometerschaal
    0 32 UM/MOD                         \ Schaal waarde in voor 8 leds
    SWAP 15 > IF  1+  THEN              \ Rond af naar hogere waarde
    DUP IF                              \ Uitkomst groter dan nul ?
        1 SWAP 1- LSHIFT                \ Ja, bepaal positie van led
\       DUP 1-  OR                      \ Vul leds daaronder in
    THEN
    NAAR-LEDS                           \ Stuur leds aan
    ;
 
: TOON-ADC      ( -- )                  \ Toon AD-omzetting op LEDS
    SETUP  -1 SETDIR LEDS               \ Installeer Forth stacks
    1 SETDIR ADC-KLOK
    0 SETDIR ADC-DATA  SET ADC-DATA     \ Ingang met pullup
    1 SETDIR ADC-SELECTEER
    KNIPPER
    ADC DROP                            \ Eerste AD-omzetting is ongeldig
    BEGIN
        ADC  BEELD-AF                   \ Lees ADC, en toon uitkomst
    AGAIN
    ;  MAIN

\ Einde
