\ Relais aansturing met afvalvertraging, 184 bytes.

90S2313                                 \ Compileer voor AT90S2313
NEEDS TARGET.FRT

PORTB 3 BIT-SFR RELAIS                  \ Relais uitgang PB.3

: RELAIS-AAN    SET RELAIS ;
: RELAIS-UIT    CLEAR RELAIS ;

: SETUP-RELAIS      ( -- )              \ Zet relais uit
    1 SETDIR RELAIS
    RELAIS-UIT
    ;

\ Relais besturing demonstratie

PORTD 3 BIT-SFR INGANG                  \ Ingang met schakelaar PD.3

: LEES-INGANG       ( -- flag )         \ Bemonster de schakelaar
    0                                   \ Beginwaarde
    20 FOR                              \ Neem 20 monsters
        5 MS                            \ Wacht 5 millisec.
        FROM INGANG INVERT              \ Lees ingang ( $00 of $FF )
        1 AND                           \ Maskeer laagste bit
        +                               \ Tel bij beginwaarde op
    NEXT
    20 =                                \ Alle 20 monsters waar ?
    ;

: 10MS              ( u -- )            \ Wacht u maal 10 millisec.
    FOR  10 MS  NEXT
    ;

: BEDIEN-RELAIS     ( -- u )            \ Relais snel aan, vertraagd uit 
    LEES-INGANG IF                      \ Schakelaar gesloten ?
        RELAIS-AAN                      \ Ja, ...
    ELSE
        100 10MS  RELAIS-UIT            \ Nee, na 1 sec. het relais uit zetten
    THEN                                \ dit is een afval vertraging
    ;

: RELAIS-STURING    ( -- )              \ Bedien relais via schakelaar
    SETUP   SETUP-RELAIS                \ Zet relais uit
    0 SETDIR INGANG  SET INGANG         \ Ingang met pullup
    100 10MS  RELAIS-AAN                \ Toon opstarten door aan/uit 
    200 10MS  RELAIS-UIT                \ schakelen van het relais
    BEGIN
        BEDIEN-RELAIS
    AGAIN
    ;  MAIN
