\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : EXEC1.FRT
\ DESCRIPTION : Executie tabel in AVR ByteForth
\ CATEGORY    : Applicatie, afmeting: 106 bytes.
\ AUTHOR      : Willem Ouwerkerk, June 20, 2000
\ LAST CHANGE : Willem Ouwerkerk, June 21, 2000
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

:: EXEC:
    CREATE              ( xt1 .. xtn n -- )
        DUP 1- , ALIGN  0 DO  ' D,  LOOP
    DOES>               ( n -- i*x )
        2>R  2R@ ROM@  MIN 1+ 2* 0
        2R> D+  2ROM@ EXECUTE
        ;

: NUL   0 ;
: EEN   -1 ;
: TWEE  -2 ;
: DRIE  -3 ;

4 EXEC: WIM  NUL EEN TWEE DRIE

                              ( Einde )
