\ I2C in en uitvoer met PCF8574, totale codelengte: 400 bytes

90S2313                                 \ Code draait op een 90S2313
NEEDS TARGET.FRT                        \ Laad systeem constanten
4 SET-CRYSTAL

\ I2C primitieven voor een 4 MHz kristal

NEEDS I2C-PRIM.FRT
NEEDS I2C-8574.FRT

\ De tweede I2C applicatie is een looplicht met variabele snelheid

: 10MS          ( u -- )                \ Wacht u maal 10 millisec.
    FOR  10 MS  NEXT
    ;

: INGANG        ( -- +n )               \ Lees data van PCF8574 op adres 0
    I/O-ID1 @BYTE INVERT  $F AND  1+ 2* \ +n is getal tussen 2 en 32
    ;

: NAAR-LEDS     ( byte -- )             \ Stuur data naar PCF8574 op adres 0
    INVERT  $0F OR  I/O-ID1 !BYTE       \ De lage 4 bits zijn ingangen
    ;

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    -1 NAAR-LEDS  25 10MS
    0  NAAR-LEDS  25 10MS
    ;

: LOOPLICHT     ( -- )                  \ Toon een looplicht op de leds
    SETUP  SETUP-I2C  KNIPPER
    BEGIN
        4 0 DO
            1 I 4 + LSHIFT NAAR-LEDS    \ Zet een led aan
            INGANG 10MS                 \ Wacht 20 tot 320 millisec.
        LOOP
    AGAIN
    ;  MAIN                             \ LOOPLICHT start op na een reset
