\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : MEGASLP.FRT
\ DESCRIPTION : Demonstreer gebruik van Power-down mode
\ CATEGORY    : Voorbeeld, afmeting: 214 bytes.
\ AUTHOR      : Willem Ouwerkerk, March 05, 2000
\ LAST CHANGE : Willem Ouwerkerk, Mei 19, 2000
\ ----------------------------------------------------------------------

mega103                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

PORTB SFR LEDS                          \ 8 Leds op poort B

: DEMO          ( -- )
    SETUP  -1 SETDIR LEDS               \ Leds zijn uitgangen
    CLEAR LEDS  250 MS                  \ Leds aan en wacht
    BEGIN
        8 FOR                           \ 8 maal
            8 FOR                       \ looplicht
                1 I' 1- LSHIFT          \ Maak bitpatroon
                INVERT TO LEDS  50 MS   \ Zet led aan en wacht
            NEXT
        NEXT
        SET LEDS                        \ Alle leds uit
        SLEEP                           \ Ga maar slapen
    AGAIN
    ;  MAIN

                              ( Einde )
