\ ==============================================================
\ [TITLE]     AVR ByteForth RS232 protoboard demo
\ [FILE]      RS232.FRT
\ [CATEGORY]  Test prototype board: 378 bytes
\ [VSN]       1.00 
\ [CREATED]   April 9, 1995, Willem Ouwerkerk 
\ [LASTCHNGD] May 22, 2002, Willem Ouwerkerk 
\ [COPYRIGHT] De Elektrise Schaar (C) 1995-2002
\ [USES]      AVR ByteForth cross compiler
\ [PURPOSE]   RS232 I/O on target with use of timer 1.
\ ==============================================================

mega8515                                \ Setup compiler
NEEDS TARGET.FRT

1 SET-CRYSTAL                           \ Select xt
NEEDS RS232s.FRT
NEEDS MS.FRT


\ A small RS232 text demo

PORTB 3 BIT-SFR LED

ATOM INLINE$

: HANDLE-INPUT      ( -- )
    BEGIN
        CR ." > " KEY
        DUP &A = IF  ." Aap "   THEN
        DUP &B = IF  ." Boef "  THEN
        DUP &C = IF  ." Chip "  THEN
        CLEAR LED  100 MS  SET LED
    &Q = UNTIL
    ;

: TEXT-DEMO         ( -- )
    SETUP  SETUP-RS232  1 SETDIR LED
    100 MS  SET LED
    BEGIN
        PAGE ." RS232 test for protoboard VSN 1.00"
        HANDLE-INPUT
    AGAIN
    ;  MAIN

\ End
