\ ==============================================================
\ [TITLE]     AVR ByteForth single number BCD library. 
\ [FILE]      BCD.FRT
\ [CATEGORY]  Library, 110 bytes.
\ [VSN]       1.00
\ [CREATED]   May 30, 2003, Willem Ouwerkerk 
\ [LASTCHNGD] May 30, 2003, Willem Ouwerkerk 
\ [COPYRIGHT] De Elektrise Schaar (C) 2003-
\ [USES]      ByteForth cross compiler
\ [PURPOSE]   BCD conversion primitives
\ ==============================================================

\G Converteer het binair getal '+n1' naar BCD getal '+n2'.
: >BCD          ( +n1 -- +n2 )          \ Bcd "to-bcd"
    S>D 10 UM/MOD CSWAP OR
    ;

\G Converteer het BCD getal '+n1' naar binair getal '+n2'.
: BCD>          ( +n1 -- +n2 )          \ Bcd "bcd-from"
    >R R@ $F AND
    R> CSWAP $F AND
    10 *  +
    ;

\ Einde
